﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.master" AutoEventWireup="true"
    CodeBehind="Default.aspx.cs" Inherits="igGridColumnHiding._Default" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <h2>
        Welcome to ASP.NET!
    </h2>
    <div class="holder">
    <input type="button" id="Button" />
    </div>
    <table id="gridTarget"></table>
    <script type="text/javascript">
        $(document).ready(function () {
            // initializing our data source
            var data_url = "http://odata.netflix.com/Catalog/Titles?$format=json&$callback=?";
            var jsonp = new $.ig.JSONPDataSource({ dataSource: data_url, responseDataKey: "d.results" });
            var visible_count = 0; // using this in custom column chooser functionality

            /* defining an array of object which we'll use.
            /  the reason for using this approach is to be able to programatically generate
               checkboxes with ease */

            /* we'll use these objects as a basis when setting up our grid and then generating checkboxes
               for our custom column chooser functionality. */
            var columns = [
            { text: "Movie Name", key: "Name" },
            { text: "Release Year", key: "ReleaseYear" },
            { text: "Average Rating", key: "AverageRating" }
            ];

            visible_count = columns.length;


            $("#Button").igButton({
                labelText: "Column Chooser"
            });

            // grid initialization
            $("#gridTarget").igGrid({
                autoGenerateColumns: false,
                width: 900,
                dataSource: jsonp,
                columns: [
                    { headerText: columns[0].text, key: columns[0].key },
                    { headerText: columns[1].text, key: columns[1].key, dataType: "number" },
                    { headerText: columns[2].text, key: columns[2].key, dataType: "number" }
                ],
                features: [
                { name: "Paging", pageSize: 5 },
                { name: "Hiding", columnHidden: function (evt, ui) { // making sure the checkboxes above the grid are updated
                    $(".holder").find("input[value='" + ui.columnKey + "']").removeAttr("checked");
                }, columnShown: function (evt, ui) { // also for updating the checkboxes above our grid
                    $(".holder").find("input[value='" + ui.columnKey + "']").attr("checked", "checked");
                }
                }
                ]
            });

            // adds checkboxes for toggling column visibility
            $.each(columns, function () {
                $(".holder").append("<input type='checkbox' checked='checked' class='columns' value='" + this.key + "'//> " + this.text);
            });

            // this brings up the Column Chooser programatically
            $("#Button").click(function () {
                $("#gridTarget").igGridHiding("hideColumnChooser");
                $("#gridTarget").igGridHiding("showColumnChooser");
            });

            // this emulates the functionality of a column chooser
            $(".columns").click(function (obj) {
                var target = obj.target;
                var state = $(target).attr("checked");
                if (!state) {
                    if (visible_count > 1) {
                        $("#gridTarget").igGridHiding("hideColumn", $(target).val());
                        visible_count--;
                    }
                    else return false;
                }
                else {
                    $("#gridTarget").igGridHiding("showColumn", $(target).val());
                    visible_count++;
                }
            });
        });
    </script>
</asp:Content>
